class DataContract < Module
  class ContractList < Array
    attr_reader :obj

    def initialize(obj=nil)
      @obj = obj
    end

    def get(mod)
      contract = find { |contract| contract.mod == mod }
      raise ContractError, "No contract for #{mod.name}" unless contract
      contract
    end

    def [](mod)
      get mod
    end

    def assignable(receiver)
      assignable_contracts = self.class.new obj

      each do |contract|
        if contract.assignable? receiver
          assignable_contracts << contract
        end
      end

      assignable_contracts
    end

    def scatter(receiver, contract_module=nil)
      Scatter.! self, receiver, contract_module
    end
  end
end
