class DataContract < Module
  class Scatter
    include Initializer

    initializer :contract_list, :source, :receiver, :assignable_contracts, :contract_module

    def self.!(contract_list, receiver, contract_module)
      assignable_contracts = contract_list.assignable(receiver)
      instance = new contract_list, contract_list.obj, receiver, assignable_contracts, contract_module
      instance.!
    end

    def !
      if assignable_contracts.empty?
        raise ContractError, "#{receiver.class.name} cannot be assigned from #{source.class.name} without a shared or compatible contract"
      end

      if contract_module
        @assignable_contracts = specific_contract
      end

      assignable_contracts.each do |contract|
        contract.scatter receiver
      end

      receiver
    end

    def specific_contract
      contract = contract_list[contract_module]

      unless assignable_contracts.include? contract
        raise ContractError, "#{receiver.class.name} cannot be assigned from #{contract_module.name} without a shared or compatible contract"
      end

      [contract]
    end
  end
end
